<script setup lang="ts">
import { useCheckStockStore } from '@/stores/checkStock';
import { useStockStore } from '@/stores/stock';
import type { CheckStock } from '@/types/CheckStock';
import type { Stock } from '@/types/Stock';
import { computed, nextTick, ref } from 'vue';
import { onMounted } from 'vue';
import type { VForm } from 'vuetify/components';

const stockStore = useStockStore()
const CheckStockStore = useCheckStockStore()
const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'CheckStock Date',
        key: 'checkStockDate',
        value: 'checkStockDate'
    },
    {
        title: 'Total Use',
        key: 'totalUse',
        value: 'totalUse'
    },
    {
        title: 'EMP ID',
        key: 'employeeId',
        value: 'employeeId'
    },
    {
        title: 'EMP Name',
        key: 'employeeName',
        value: 'employeeName'
    },
    { title: '', key: 'actions', sortable: false }
]


const search = ref('')
const dialog = ref(false)
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divCheckStockItems = ref<HTMLElement | null>(null)
const dialogShowCheckStockItems = ref(false)


const filteredCheckStock = computed(() => {
    const searchValue = search.value;
    return CheckStockStore.checkStocksData.filter(CheckStockStore => {
        const formattedDate = formatDate(CheckStockStore.checkStockDate);
        return formattedDate.includes(searchValue);
    });
});

function onSubmit() { }

function closeDialog() {
    dialog.value = false
    dialogShowCheckStockItems.value = false
    nextTick(() => {
        CheckStockStore.clearCheckStock()
        CheckStockStore.clearCheckStockItems()
    })
}

async function addCheckStockItems(s: Stock) {
    const { valid } = await refForm.value!.validate()
    CheckStockStore.addCheckStockItems(s)
    if (!valid) return
    nextTick(() => {
        if (divCheckStockItems.value) divCheckStockItems.value.scrollTo(0, divCheckStockItems.value.scrollHeight)
    })
}

async function showCheckStockDialog(item: CheckStock) {
    if (!item.id) return
    await CheckStockStore.getCheckStock(item.id)
    dialogShowCheckStockItems.value = true
}

async function save() {
    const { valid } = await refForm.value!.validate()
    if (!valid) return
    if (CheckStockStore.checkStockItems.length === 0) return

    CheckStockStore.saveCheckStock()
    closeDialog()
}

function formatDate(date: Date) {
    const formattedDate = new Date(date).toLocaleDateString('en-GB', {
        day: '2-digit',
        month: '2-digit',
        year: 'numeric'
    });
    return formattedDate
}

onMounted(async () => {
    await stockStore.getStocks()
    await CheckStockStore.getCheckStocks()
})
</script>

<template>
    <div style="width: 95%;height: 100%;">
        <v-card-title class="d-flex align-center pe-2">
            <v-spacer></v-spacer>
        </v-card-title>
        <v-data-table :headers="headers" :items="filteredCheckStock">
            <template v-slot:[`item.checkStockDate`]="{ value }">
                {{ formatDate(value) }}
            </template>
            <template v-slot:top>
                <v-toolbar flat color="#F48FB1">
                    <v-toolbar-title>
                        <v-icon icon="mdi-text-box-check">
                        </v-icon>Check Stock</v-toolbar-title>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    <v-spacer></v-spacer>
                    <!--orderReceipt Dialog-->
                    <v-dialog v-model="dialog" persistent width="1440" height="800">
                        <template v-slot:activator="{ props }">
                            <v-btn color="#ECEFF1" variant="flat" v-bind="props">
                                <v-icon icon="mdi-plus">
                                </v-icon>
                                New Check Stock
                            </v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="text-h5">Check Stock Items</span>
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-select v-model="CheckStockStore.editedCheckStockItem.stock"
                                                    label="Please Select Stock" :items="stockStore.stocks"
                                                    item-title="name" return-object>
                                                </v-select>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field type="number"
                                                    v-model.number="CheckStockStore.editedCheckStockItem.remain"
                                                    :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable
                                                    label="remain" placeholder="Enter your remain"></v-text-field>
                                            </v-col>
                                        </v-row>
                                    </v-container>
                                    <v-card-actions aria-label="right">
                                        <v-btn color="green" variant="flat"
                                            @click="addCheckStockItems(CheckStockStore.editedCheckStockItem.stock!)">ADD</v-btn>
                                        <v-btn color="red" variant="flat"
                                            @click="CheckStockStore.clearCheckStockItems()">Cancel</v-btn>
                                    </v-card-actions>
                                </v-form>
                                <small>*indicates required field</small>

                                <div ref="divCheckStockItems" style="height: 400;overflow: auto;">
                                    <v-sheet min-width="400" max-width="1340" height="400" elevation="4">
                                        <v-table>
                                            <template v-slot:default>
                                                <thead>
                                                    <tr>
                                                        <th>#</th>
                                                        <th>name</th>
                                                        <th>last qty</th>
                                                        <th>use</th>
                                                        <th>remain</th>
                                                        <th></th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr v-for="(item, index) of CheckStockStore.checkStockItems"
                                                        :key="item.id">
                                                        <td>{{ index + 1 }}</td>
                                                        <td>{{ item.name }}</td>
                                                        <td>{{ item.lastQty }}</td>
                                                        <td>{{ item.use }}</td>
                                                        <td>{{ item.remain }}</td>
                                                        <td><v-btn icon="mdi-delete" density="compact"
                                                                @click="() => { CheckStockStore.removeCheckStockItems(item) }"></v-btn>
                                                        </td>
                                                    </tr>
                                                </tbody>
                                            </template>
                                        </v-table>
                                    </v-sheet>
                                </div>
                            </v-card-text>

                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red" variant="flat" @click="closeDialog">
                                    Close
                                </v-btn>
                                <v-btn color="green" variant="flat" @click="save">
                                    Save
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    <v-text-field class="mx-2" v-model="search" prepend-inner-icon="mdi-magnify" density="compact"
                        label="Search" single-line flat hide-details variant="outlined"></v-text-field>
                    <!-- showCheckStockItems -->
                    <v-dialog v-model="dialogShowCheckStockItems" width="520" height="800" persistent>
                        <v-card>
                            <v-card-title class="text-h5">CheckStock Item</v-card-title>
                            <div style="margin: 10px;">
                                <v-spacer></v-spacer>
                                <td>วันที่สั่งสินค้า: {{
            formatDate(CheckStockStore.editedCheckStock.checkStockDate) }}
                                </td>
                                <v-spacer></v-spacer>
                                <td>ผู้ซื้อสินค้า: {{ CheckStockStore.editedCheckStock.employeeName }}</td>
                                <v-spacer></v-spacer>
                                <v-card-text>
                                    <v-table>
                                        <template v-slot:default>
                                            <thead>
                                                <tr>
                                                    <th>#</th>
                                                    <th>name</th>
                                                    <th>last qty</th>
                                                    <th>use</th>
                                                    <th>remain</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr v-for="(item, index) of CheckStockStore.editedCheckStock.checkStockItems!"
                                                    :key="item.id">
                                                    <td>{{ index + 1 }}</td>
                                                    <td>{{ item.name }}</td>
                                                    <td>{{ item.lastQty }}</td>
                                                    <td>{{ item.use }}</td>
                                                    <td>{{ item.remain }}</td>
                                                </tr>
                                            </tbody>
                                        </template>
                                    </v-table>
                                    <td>จำนวนสินค้าที่ใช้ไป:{{ CheckStockStore.editedCheckStock.totalUse }} Unit</td>
                                    <v-spacer></v-spacer>
                                </v-card-text>
                            </div>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red" variant="flat" @click="closeDialog">
                                    Close
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="showCheckStockDialog(item)"> mdi-receipt-text</v-icon>
            </template>
        </v-data-table>
    </div>
</template>
